package com.soundapp.alisajung.ambientsounds;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import java.util.ArrayList;

public class ManagePlaylistsActivity extends AppCompatActivity {

    public static int PLAYLIST_ADD = 0;
    public static int PLAYLIST_EDIT = 1;
    public static String EDIT_MODE = "editmode";

    public static int RESULT_NEW_PLAYLIST = 0;
    public static int RESULT_CANCEL = 1;
    public static int RESULT_EDITED = 2;
    public static int RESULT_DELETED = 3;

    private ArrayList<Playlist> playlists;
    private ArrayList<String> playlist_names;
    private ListView playlistView;
    private ArrayAdapter arrayAdapater;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_manage_playlists);
        playlistView = (ListView) findViewById(R.id.playlists);

        playlists = new ArrayList<Playlist>();
        playlist_names = new ArrayList<String>();
        arrayAdapater = new ArrayAdapter(getApplicationContext(), android.R.layout.simple_list_item_1, playlist_names);
        playlistView.setAdapter(arrayAdapater);


    }

    public void backToMainMenu(View view){
        Log.d("Hallo", "Back To main Menu pressed");
        finish();
    }

    public void addPlaylist(View view){
        Log.d("Hallo", "TODO: Add Playlist");

        Intent intent = new Intent(this, PlaylistEditor.class);
        int message = PLAYLIST_ADD;
        intent.putExtra(EDIT_MODE,PLAYLIST_ADD);
        startActivityForResult(intent,PLAYLIST_ADD);
    }

    public void onActivityResult(final int requestCode, int resultCode, final Intent data){
        if (requestCode == PLAYLIST_ADD && resultCode == RESULT_NEW_PLAYLIST){
            Log.d("Hopefully", "received new playlist");
            Playlist p = (Playlist)data.getSerializableExtra("New Playlist");
            if (playlist_names.contains(p.getName())){
                Log.d("ERROR", "Playlist with this name already exists. abort. TODO show error message in app.");
                return;
            }
            playlists.add(p);
            playlist_names.add(p.getName());
            Log.d("Playlist names: ", playlist_names.toString());
            arrayAdapater = new ArrayAdapter(getApplicationContext(), android.R.layout.simple_list_item_1, playlist_names);
            playlistView.setAdapter(arrayAdapater);

            //TODO when activity is finished, pass playlist list to main activity
            //should work just like playlist is passed to this.
        }
    }
}
